%%
% This script describes the processing completed by Mike Berks to analyze
% Leo Georgiou's control dataset, comprising 8 healthy volunteers that
% underwwent DCE-MRI of the liver using the active contrast agent
% Gadoxetate. A paper on this data, fitting a bi-exponential tracer-kinetic
% model to average ROI time-series data was published here:
%
% The work below extends this analysis to perform voxel-wise fitting and 
% model comparison 
%
% The data was given to Mike by Leo's supervisor Jo Naish, in the form of
% the zipped raw DICOM files.
%
% Complete steps for processing the data:
% 1) Unzip the whole data set into suitable data directories
%
% 2) Sort raw DICOM data into variable FA and DCE sequences and save
% indiviudal volumes to Analyze files
%
% 3) Create T1 map from variable flip angles
%
% 4) Detect aorta and compute AIFs
%
% 5) Create temporal means of DCE sequence at key time-points, upload the
% data to QUBI server for radiolgist annotation of ROIs
%
% 6) Crop DCE volumes at extent of liver ROI for space/memory
%
% 7) Motion correct the cropped DCE volumes...
%  i) Use ANTs to compute local transformation between neighbouring
%  temporal images
%  ii) Compute motion model from resulting deformation fields
%  iii) Register to dynamic mean using motion model
%
%
% 8) Fit DCE models to motion corrected sequence
%
% 9) Perform post-fit model selection and parameter analysis
%
% See also: GEORGIOU_UNZIP_RAW_DATA, GEORGIOU_DCM_TO_ANALYZE, GEORGIOU_AIF,
% GEORGIOU_CROP_DATA, GEORGIOU_MAKE_SLICE_VOLUMES
%% 
%--------------------------------------------------------------------------
%%
study_dir = 'C:/isbe/qbi/data/georgiou_controls/';

%% 1) Unzip the whole data set into suitable data directories
georgiou_batch_fun(@georgiou_unzip_raw_data, study_dir, 1, 1:2,...
    'zip_dir', 'C:/Users/momeemb2/Dropbox (The University of Manchester)/MRWT012');

%% 2) Sort raw DICOM data into variable FA and DCE sequences and save
% indiviudal volumes to Analyze files
georgiou_batch_fun(@georgiou_dcm_to_analyze, study_dir, 1:8, 1:2);

%% 3) Create T1 map from variable flip angles
georgiou_batch_fun(@georgiou_T1_map, study_dir, 1:8, 1:2,...
    'make_FA_means', 1,...
    'do_T1_map', 1,...
    'do_T1_error', 0,...
    'do_FA_std', 0,...
    'FA_mean_dir', 'FA_means',...
    'T1_dir', 'mdm_analysis_T1',...
    'reg_sfx', [],...
    'view_slice', 24,...
    'overwrite', 1,...
    'dummy_run', 0);

%% 4) Detect aorta and compute AIFs
georgiou_batch_fun(@georgiou_aif, study_dir, 1:8, 1:2);
georgiou_group_aif(study_dir, 264);
%% 5) Create temporal means of DCE sequence at key time-points, upload the
% data to QUBI server for radiolgist annotation of ROIs
georgiou_batch_fun(@georgiou_make_postcon_means, study_dir, 1:8, 1:2);

%% 6) Crop DCE volumes at extent of liver ROI for space/memory
georgiou_batch_fun(@georgiou_crop_data, study_dir, 1:8, 1:2,...    
    'dynamic_dir', 'dynamic',...
    'cropped_dir', 'dynamic_cropped',...
    'T1_dir', 'mdm_analysis_T1',...
    'roi_masks_dir', 'roi_masks',...
    'n_random_voxels', 1000,...
    'make_subset_mask', 1,...
    'do_plot', 1);

%% 7) Motion correct the cropped DCE volumes...
%  i) Use ANTs to compute local transformation between neighbouring
%  temporal images
%  ii) Compute motion model from resulting deformation fields
%  iii) Register to dynamic mean using motion model
% Note the initial ANTs fixed and local registrations are computed on the
% CSF, called from a python script
georgiou_batch_fun(@dce_motion_model_registration, study_dir, 1:8, 1:2,...
    'results_root', 'Q:/data/MB/',...
    'n_vols', 264,...
    'load_vols', 2,...
    'do_fixed', 1,...
    'do_local_transforms', 1,...
    'do_constrained_pca', 1,...
    'do_apply_pca', 1,...
    'do_write_pca_dyn', 1,...
    'do_write_fixed_dyn', 1,...
    'do_T1_FA_vols', 0,...
    'do_T1_FA_means', 0,...
    'dynamic_dir', 'dynamic_cropped',...
    'scale', 2,...
    'pca_model_vols', 20:96,...
    'pca_thresh', 0.95,...
    'num_pca_modes', 10,...
    'max_iter', 100,...
    'view_slice', [],...
    'ants_overwrite', 0,...
    'save_figs', 1,...
    'debug', 1);

%% 8) Fit DCE models to motion corrected sequence
%% i) Take a central slice of of the motion corrected volumes for fitting
georgiou_batch_fun(@georgiou_make_slice_volumes, study_dir, 1:8, 1:2,...
    'dynamic_dir', 'dynamic_cropped_ants',...
    'slice_dir', 'dynamic_central_slice_ants',...
    'T1_dir', 'mdm_analysis_T1',...
    'T1_name', 'T1_cropped.hdr',...
    'S0_name', 'S0_cropped.hdr',...
    'roi_masks_dir', 'roi_masks',...
    'roi_name', 'liver_mask_cropped.hdr');

%% ii) Fit DCE models in Madym
% We fit the following (motion ocrrected unless otherwise stated):
% - full liver volume for non-motion corrected data, 80 time-points
% - full liver volume, 80 time-points
% - 1000 voxels subset, 80 time-points
% - 1000 voxels subset, 138 time-points
% - 1000 voxels subset, 234 time-points
% - central liver slice, 80 time-points
% - central liver slice, 138 time-points
% - central liver slice, 234 time-points

% see  code/python/projects/georgiou_controls/georgiou_madym_csf.sh
% code/python/projects/georgiou_controls/georgiou_madym_subset_csf.sh
% code/python/projects/georgiou_controls/georgiou_madym_slice_csf.sh
%% iii)
% Compute temporal residuals from initial fit
analysis_dirs = {
    'mdm_analysis_264_subset_gaif_ants_DIBEM_f137'
    'mdm_analysis_264_subset_gaif_ants_DIBEM_f37'
    'mdm_analysis_264_subset_gaif_ants_DIBEM_f7'};
georgiou_batch_fun(@make_temporal_residuals, study_dir, 1:8, 1:2,...
    'dyn_conc_dir', 'mdm_analysis_264_subset_gaif_ants_DIBEM_f7',...
    'dynamic_dir', 'dynamic_cropped_ants',...
    'n_vols', 264,...
    'analysis_dirs', analysis_dirs,...
    'roi_mask_path', 'roi_masks/liver_mask_cropped_subset.hdr',...
    'save_dir', 'dynamic_cropped_ants',...
    'update_xtr_files', 1,...
    'plot', 1);
georgiou_batch_fun(@make_temporal_residuals, study_dir, 1:8, 1:2,...
    'save_dir', 'dynamic_cropped_ants',...
    'dynamic_dir', 'dynamic_cropped_slice_ants',...
    'n_vols', 264,...
    'use_existing', 1,...
    'update_xtr_files', 1,...
    'plot', 0);

%Do sequential fit of tau
georgiou_batch_fun(@georgiou_fit_tau, study_dir, 1:8, 1:2);
%%
%Do sequential fit of tau
georgiou_batch_fun(@georgiou_fit_tau, study_dir, 1:8, 1:2,...
    'save_dir', 'tau_fit_slice',...
    'dyn_dir', 'dynamic_cropped_slice_ants',...
    'T1_path', 'mdm_analysis_T1/T1_cropped_slice.hdr',...
    'roi_mask_path', 'roi_masks/liver_mask_cropped_slice.hdr');

%% 9) Perform post-fit model selection and parameter analysis
experiment_info = {
    '', '', '_subset', 80 %1
    '_subset_ants', '_ants', '_subset', 80 %2 COMPLETE
    '_138_subset_ants','_ants', '_subset', 138 %3 COMPLETE
    '_264_subset_ants','_ants', '_subset', 264 %4 COMPLETE
    '_subset_gaif_ants', '_ants', '_subset', 80 %5 COMPLETE
    '_138_subset_gaif_ants','_ants', '_subset', 138 %6 COMPLETE
    '_264_subset_gaif_ants','_ants', '_subset', 264 %7 COMPLETE
    '_subset_tn_gaif_ants', '_ants', '_subset', 80 %8 COMPLETE
    '_138_subset_tn_gaif_ants','_ants', '_subset', 138 %9 COMPLETE
    '_264_subset_tn_gaif_ants','_ants', '_subset', 264 %10 COMPLETE
    '_subset_tn_gaif_r6_ants', '_ants', '_subset', 80 %11
    '_138_subset_tn_gaif_r6_ants','_ants', '_subset', 138 %12
    '_264_subset_tn_gaif_r6_ants','_ants', '_subset', 264 %13
    '_slice_tn_gaif_ants','_slice_ants', '_slice', 80 %14
    '_138_slice_tn_gaif_ants','_slice_ants', '_slice', 138 %15
    '_264_slice_tn_gaif_ants','_slice_ants', '_slice', 264}; %16
for i_exp = 1:length(experiment_info)
    model_base = ['mdm_analysis' experiment_info{i_exp,1} '_DIBEM_'];
    roi = {
       ['roi_masks/liver_mask_cropped' experiment_info{i_exp,3} '.hdr']};
   
    roi_exclusive_matrix = [0 1; 0 0];
    
    results_dir = ['results/mdm_summary' experiment_info{i_exp,1}];
    
    georgiou_batch_fun(@DIBEM_postfit_analysis, study_dir, 1:8, 1:2,...
        'model_base', model_base,...
        'dynamic_dir', ['dynamic_cropped' experiment_info{i_exp,2}],...
        'conc_dir', [model_base 'f137'],...
        'T1_dir', 'mdm_analysis_T1',...
        'model_subscripts', {'f137', 'f37', 'f7'},...
        'model_postscript', '',...
        'roi_mask_paths', roi,...
        'roi_names', {'liver'},...
        'n_vols', experiment_info{i_exp,4},...
        'injection_image', 20,...
        'use_linear_base', 1,...
        'model_k', [ 5 6 7],...
        'load_vols', 1,...
        'load_parameters', 1,...
        'load_rois', 1,...
        'do_selection_stats', 1,...
        'do_phys_stats', 1,...
        'do_region_analysis', 1,...
        'do_region_opt_analysis', 0,...
        'erode_roi_edges', [0 0],...
        'discard_edge_slices', [0 0],...
        'roi_exclusive_matrix', roi_exclusive_matrix,...
        'discard_noisy_voxels', 0,...1
        'roi_analysis',[],...
        'temporal_noise', [],...
        'results_dir', results_dir);
end

%%
experiment_info = {
    '_subset_tn_gaif_ants', '_ants', '_subset', 80, '_tau' 
    '_138_subset_tn_gaif_ants','_ants', '_subset', 138, '_tau'
    '_264_subset_tn_gaif_ants','_ants', '_subset', 264, '_tau'
    '_subset_tn_gaif_r6_ants', '_ants', '_subset', 80, '_tau'
    '_138_subset_tn_gaif_r6_ants','_ants', '_subset', 138, '_tau'
    '_264_subset_tn_gaif_r6_ants','_ants', '_subset', 264, '_tau'
    '_slice_tn_gaif_ants', '_ants', '_slice', 80, '_tau' 
    '_138_slice_tn_gaif_ants','_ants', '_slice', 138, '_tau'
    '_264_slice_tn_gaif_ants','_ants', '_slice', 264, '_tau'
    '_subset_tn_gaif_ants', '_ants', '_subset', 80, '_fa' 
    '_138_subset_tn_gaif_ants','_ants', '_subset', 138, '_fa'
    '_264_subset_tn_gaif_ants','_ants', '_subset', 264, '_fa'
    '_subset_tn_gaif2_ants', '_ants', '_subset', 80, '_tau' 
    '_138_subset_tn_gaif2_ants','_ants', '_subset', 138, '_tau'
    '_264_subset_tn_gaif2_ants','_ants', '_subset', 264, '_tau'};

for i_exp = 13:15
    model_base = ['mdm_analysis' experiment_info{i_exp,1} '_DIBEM_'];
    roi = {
       ['roi_masks/liver_mask_cropped' experiment_info{i_exp,3} '.hdr']};
   
    roi_exclusive_matrix = [0 1; 0 0];
    
    results_dir = ['results/mdm_summary' experiment_info{i_exp,1} ...
        experiment_info{i_exp,5}];
    
    if i_exp <= 9 || i_exp > 12
        model_subscripts = {'f1367', 'f367', 'f67'};
    else
        model_subscripts = {'f13567', 'f3567', 'f567'};
    end
    
    georgiou_batch_fun(@DIBEM_postfit_analysis, study_dir, 1:8, 1:2,...
        'model_base', model_base,...
        'dynamic_dir', ['dynamic_cropped' experiment_info{i_exp,2}],...
        'conc_dir', [model_base model_subscripts{1}],...
        'T1_dir', 'mdm_analysis_T1',...
        'model_subscripts', model_subscripts,...
        'model_postscript', '',...
        'roi_mask_paths', roi,...
        'roi_names', {'liver'},...
        'n_vols', experiment_info{i_exp,4},...
        'injection_image', 20,...
        'use_linear_base', 1,...
        'model_k', [ 5 6 7],...
        'load_vols', 1,...
        'load_parameters', 1,...
        'load_rois', 1,...
        'do_selection_stats', 1,...
        'do_phys_stats', 1,...
        'do_region_analysis', 1,...
        'do_region_opt_analysis', 0,...
        'erode_roi_edges', [0 0],...
        'discard_edge_slices', [0 0],...
        'roi_exclusive_matrix', roi_exclusive_matrix,...
        'discard_noisy_voxels', 0,...1
        'roi_analysis',[],...
        'temporal_noise', [],...
        'results_dir', results_dir);
end
%%
results_dirs = {
    'results/mdm_summary_slice_tn_gaif_ants_tau/'
    'results/mdm_summary_138_slice_tn_gaif_ants_tau/'
    'results/mdm_summary_264_slice_tn_gaif_ants_tau/'};
for i_exp = 1:3
    georgiou_batch_fun(@georgiou_make_figures, study_dir, 8, 1:2,...
        'results_dir', results_dirs{i_exp},...
        'dyn_dir', 'dynamic_cropped_slice_ants',...
        'n_vols', 100,...
        'do_param_map_figs', 1,...
        'do_aic_class_figs', 1,...
        'do_dyn_figs', 1,...
        'do_tse_figs', 1,...
        'display_figs', 0,...
        'save_figs', 1,...
        'mean_start', 40,...
        'tse_scaling', 0.01);
end